unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, QuickRpt, ExtCtrls, TeeProcs, TeEngine, Chart, DBChart, QrTee, Series,
  TeeEdit, StatChar, StdCtrls;

type
  TmwLineSeries = class(TLineSeries)
  protected
    procedure DrawValue(ValueIndex:Integer); override;
  end;

  TForm1 = class(TForm)
    ChartEditor1: TChartEditor;
    Chart1: TChart;
    Series3: TAreaSeries;
    Series2: TLineSeries;
    Series1: TLineSeries;
    Series4: TLineSeries;
    Memo1: TMemo;
    procedure Chart1DblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Chart1Zoom(Sender: TObject);
  private
    FmwSeries1: TmwLineSeries;
    FmwSeries2: TmwLineSeries;
    FmwSeries4: TmwLineSeries;
    function CreateCustomLineSeries(strTitle: string;
      colColor: TColor): TmwLineSeries;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Chart1DblClick(Sender: TObject);
begin
  Self.ChartEditor1.Execute;
end;

procedure TForm1.Chart1Zoom(Sender: TObject);
const strFORMAT = 'Zoomed to (%.9f, %.9f), (%.9f, %.9f)';
var strBuffer: string;
begin
  strBuffer:=Format(strFORMAT, [Self.Chart1.BottomAxis.Minimum,
    Self.Chart1.LeftAxis.Minimum, Self.Chart1.BottomAxis.Maximum,
    Self.Chart1.LeftAxis.Maximum]);
  Self.Memo1.Lines.Add(strBuffer);
end;

function TForm1.CreateCustomLineSeries(strTitle: string;
  colColor: TColor): TmwLineSeries;
begin
  Result:=TmwLineSeries.Create(Self);
  with Result do
    begin
      Marks.Arrow.Visible:=True;
      Marks.Callout.Brush.Color:=clBlack;
      Marks.Callout.Arrow.Visible:=True;
      Marks.Visible:=False;
      Title:=strTitle;
      LinePen.Color:=colColor;
      LinePen.Width:=2;
      Pointer.InflateMargins:=True;
      Pointer.Style:=psRectangle;
      Pointer.Visible:=False;
      XValues.Name:='X';
      XValues.Order:=loNone;
      YValues.Name:='Y';
      YValues.Order:=loNone;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.FmwSeries1:=Self.CreateCustomLineSeries(Series1.Title,
    Series1.LinePen.Color);
  Self.FmwSeries2:=Self.CreateCustomLineSeries(Series2.Title,
    Series2.LinePen.Color);
  Self.FmwSeries4:=Self.CreateCustomLineSeries(Series4.Title,
    Series4.LinePen.Color);
  Self.Chart1.SeriesList.Delete(Self.Chart1.SeriesList.IndexOf(Self.Series1));
  Self.Chart1.SeriesList.Delete(Self.Chart1.SeriesList.IndexOf(Self.Series2));
  Self.Chart1.SeriesList.Delete(Self.Chart1.SeriesList.IndexOf(Self.Series4));
  Self.Chart1.AddSeries(Self.FmwSeries1);
  Self.Chart1.AddSeries(Self.FmwSeries2);
  Self.Chart1.AddSeries(Self.FmwSeries4);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Self.FmwSeries1);
  FreeAndNil(Self.FmwSeries2);
  FreeAndNil(Self.FmwSeries4);
end;

procedure TForm1.FormShow(Sender: TObject);
var intItem: integer;
begin
  for intItem:=1 to 10 do
    begin
      Self.Series3.AddXY(intItem, 15-intItem);
      Self.FmwSeries1.AddXY(intItem, (15-intItem)*1.1);
      Self.FmwSeries2.AddXY(intItem, (15-intItem)*1.2);
      Self.FmwSeries4.AddXY(intItem, (15-intItem)*1.3);
    end;
//Self.FmwSeries2.FillSampleValues(10);
//Self.Series3.FillSampleValues(10);
//Self.FmwSeries4.FillSampleValues(10);
end;

{ TmwLineSeries }

procedure TmwLineSeries.DrawValue(ValueIndex: Integer);
var XPos: Integer;
begin
  XPos:=CalcXPos(ValueIndex);
  if (XPos<$7FFF) and (XPos>-$7FFF) then
    inherited;
end;
end.
